C       HUCKEL CALCULATIONS
	DIMENSION A(20,20),ADIAG(20),U(20,20),PRS(20,20),FV(20)
	DIMENSION Z(30)
	Write (*,'('' Program HMO'')')
	Write (*,'('' Adapted from'')')
	Write (*,'('' Greenwood, H. H.'')')
	Write (*,'('' Computational Methods for Quantum Organic Chem'')')
	Write (*,'('' Wiley-Interscience, New York, 1972'')')
	Write (*,50)
  50    Format (' Enter the number of molecules in I2 format.')
	READ(*,99)NMOLS
   99   FORMAT(I2)
	DO 10 KMOLS=1,NMOLS
	WRITE(*,100)KMOLS
  100   FORMAT(1H1,13H MOLECULE NO.,I4)
	CALL INPT(N,M,A)
	Write(*,51)
  51    Format(' Enter the number of derivatives in I2 format')
	Write(*,52)
  52    Format(' If only parent compound is wanted, enter 01')
	READ(*,99)NDER
	DO 10 KDER=1,NDER
	CALL PAHY(N,A,ADIAG,Z)
	CALL MODH(A,ADIAG,Z)
	EPS=1E-16
	NIT=0
	CALL SCOFI1(N,A,ADIAG,U,NIT,EPS)
	CALL ORDR(N,A,ADIAG,U)
	CALL PMAT(N,M,U,PRS)
	CALL FVAL(N,PRS,FV,A)
	CALL OTPT(N,M,A,ADIAG,U,PRS,FV)
   10   CONTINUE
	STOP
	END
C                       SUBROUTINE input 
	SUBROUTINE INPT(N,M,HMAT)
	DIMENSION HMAT(20,20),NEGMAT(20,20)
       Write(*,53)
  53   Format(' Enter total orbitals and filled orbitals in 2(I3)')
	READ(*,99)N,M
       Write (*,54)
  54   Format(' Enter lower semimatrix row by row, I1 format')
	READ(*,100)((NEGMAT(I,J),I=1,J),J=1,N)
	DO 17 J=1,N
	DO 17 I=1,J
   17   HMAT(I,J)=-NEGMAT(I,J)
       Write(*,55)
  55   Format(' The lower semimatrix you have entered is')
	DO 16 J=1,N
   16   WRITE(*,101) (NEGMAT(I,J),I=1,J)
  101   FORMAT(40I2)
   99   FORMAT(2I3)
  100   FORMAT(80I1)
	RETURN
	END
C                  SUBROUTINE pahy
	SUBROUTINE PAHY(N,A,ADIAG,Z)
	DIMENSION A(20,20),ADIAG(20),Z(20)
	DO 18 J=1,N
	DO 17 I=1,J
   17   A(J,I)=A(I,J)
	Z(J)=1.0
   18   ADIAG(J)=A(J,J)
	RETURN
	END
C                       SUBROUTINE modh 
	SUBROUTINE MODH(A,ADIAG,Z)
	DIMENSION A(20,20),ADIAG(20),Z(20)
	Write(*,56)
  56    Format(' Enter number of elements to be modified, I2 format')
	Write(*,57)
   57   Format(' For parent compound only, hit enter ')
	READ(*,99)NMOD
	IF (NMOD)18,18,19
   19   WRITE(*,103)
 103    FORMAT(///' MODIFICATIONS')
	DO 17 K=1,NMOD
	WRITE(*,58)
  58    FORMAT(' Enter row (I2), column (I2), and new elememt (F6.3)')
	READ(*,100)I,J,X
	WRITE(*,102)I,J,X
  102   FORMAT(I3,2X,I3,3X,F7.3)
	IF(I-J)15,16,14
   16   ADIAG(J)=X
	GO TO 17
   15   A(J,I)=X
	GO TO 17
   14   A(I,J)=X
   17   CONTINUE
   99   FORMAT(I2)
  100   FORMAT(I2,I2,F6.3)
   18   RETURN
	END
C                       SUBROUTINE SCOFI1 
	SUBROUTINE SCOFI1(N,A,ADIAG,U,NIT,EPS)
	DIMENSION A(20,20),U(20,20),ADIAG(20)
	IF(NIT)10,999,10
  999   DO 8 J=1,N
	DO 9 I=1,N
    9   U(I,J)=0.0
    8   U(J,J)=1.0
   10   AMAX=0.0
	DO 11 I=2,N
	JUP=I-1
	DO 11 J=1,JUP
	AII=ADIAG(I)
	AJJ=ADIAG(J)
	AOD=A(I,J)
	ASQ=AOD*AOD
   28   IF(ASQ-AMAX)23,23,27
   27   AMAX=ASQ
   23   IF(ASQ-EPS)11,11,12
   12   DIFFR=AII-AJJ
	IF(DIFFR)13,15,15
   13   SIGN=-2.0
	DIFFR=-DIFFR
	GO TO 16
   15   SIGN=2.0
   16   TDEN=DIFFR+SQRT(DIFFR**2+4.0*ASQ)
	TANK=SIGN*AOD/TDEN
	C=1.0/(SQRT(1.0+TANK**2))
	S=C*TANK
	DO 24 K=1,N
	XJ=C*U(K,J)-S*U(K,I)
	U(K,I)=S*U(K,J)+C*U(K,I)
	U(K,J)=XJ
	IF(K-J)17,24,18
   17   XJ=C*A(J,K)-S*A(I,K)
	A(I,K)=S*A(J,K)+C*A(I,K)
	A(J,K)=XJ
	GO TO 24
   18   IF(K-I)19,24,21
   19   XJ=C*A(K,J)-S*A(I,K)
	A(I,K)=S*A(K,J)+C*A(I,K)
	A(K,J)=XJ
	GO TO 24
   21   XJ=C*A(K,J)-S*A(K,I)
	A(K,I)=S*A(K,J)+C*A(K,I)
	A(K,J)=XJ
   24   CONTINUE
	ADIAG(I)=C*C*AII+S*S*AJJ+2.0*S*C*AOD
	ADIAG(J)=C*C*AJJ+S*S*AII-2.0*S*C*AOD
	A(I,J)=0
   11   CONTINUE
	IF(AMAX-EPS)20,20,10
   20   RETURN
	END
C                       SUBROUTINE ordering
	SUBROUTINE ORDR(N,A,ADIAG,U)
	DIMENSION A(20,20),ADIAG(20),U(20,20),UTEST(20)
	DO 40 K=1,N
	ATEST=ADIAG(K)
	JTEST=K
	DO 41 J=K,N
	IF(ADIAG(J)-ATEST)42,41,41
   42   ATEST=ADIAG(J)
	JTEST=J
   41   CONTINUE
	ADIAG(JTEST)=ADIAG(K)
	ADIAG(K)=ATEST
	DO 40 I=1,N
	UTEST(I)=U(I,JTEST)
	U(I,JTEST)=U(I,K)
   40   U(I,K)=UTEST(I)
	RETURN
	END
C                       SUBROUTINE PMAT 
	SUBROUTINE PMAT(N,M,C,PRS)
	DIMENSION C(20,20),PRS(20,20)
	DO 18 IR=1,N
	DO 18 IS=1,IR
	SUM=0.0
	DO 17 J=1,M
   17   SUM=SUM+C(IR,J)*C(IS,J)
   18   PRS(IR,IS)=2.0*SUM
	RETURN
	END
C                    SUBROUTINE FVAL 
	SUBROUTINE FVAL(N,PRS,FV,A)
	DIMENSION PRS(20,20),FV(20),A(20,20)
	DO 18 J=1,N
	XNR=0.0
	DO 27 I=1,N
	IF(I-J)16,27,28
   16   IF(A(I,J)+0.1)29,29,27
   29   XNR=XNR+PRS(J,I)
	GO TO 27
   28   IF(A(J,I)+0.1)39,39,27
   39   XNR=XNR+PRS(I,J)
   27   CONTINUE
   18   FV(J)=1.732-XNR
	RETURN
	END
C                       SUBROUTINE Output
	SUBROUTINE OTPT(N,M,A,ADIAG,U,PRS,FV)
	DIMENSION A(20,20),ADIAG(20),U(20,20),PRS(20,20),FV(20)
	IND=0
	L=0
   16   L=L+1
	IF(10*L-N)17,18,18
   18   NUPP=N-10*(L-1)
	IND=1
	GO TO 77
   17   NUPP=10
   77   WRITE(*,101)
 101    FORMAT(/' ','Eigenvalues')
	KLOW=10*(L-1)+1
	KUPP=NUPP+10*(L-1)
	WRITE(*,99)(K,K=KLOW,KUPP)
  99    FORMAT(3X,'J=',3X,I3,8(7X,I3))
	WRITE(*,100)(ADIAG(K),K=KLOW,KUPP)
  100   FORMAT(/3X,8F8.4)
	WRITE(*,102)
 102    FORMAT(/' ','Eigenfunctions')
	WRITE(*,99)(K,K=KLOW,KUPP)
	DO 27 I=1,N
   27   WRITE(*,103)I,(U(I,K),K=KLOW,KUPP)
  103   FORMAT(I4,8F10.5)
	PAUSE
	IF(IND)16,16,15
   15   SUM=0.0
	DO 115 J=1,M
  115   SUM=SUM+ADIAG(J)
	SUM=2*SUM
	WRITE(*,105)SUM
  105   FORMAT(/' ','TOTAL PI-ELECTRON ENERGY=',F10.4)
	WRITE(*,104)
  104   FORMAT(/' Charge densities')
	WRITE(*,100)((1.0-PRS(I,J),I=J,J),J=1,N)
	WRITE(*,106)
  106   FORMAT(/' Free valency indices')
	WRITE(*,100)(FV(I),I=1,N)
	WRITE(*,108)
  108   FORMAT(' Bond order matrix')
	WRITE(*,100)((PRS(I,J),J=1,I),I=1,N)
	RETURN
	END
