c    PPP-SCF-NO CI
      PROGRAM SCF
      DIMENSION F(30,30),FDIAG(30),T(30,30),G(30,30),Z(30)
      DIMENSION IX(96),IY(96)
      DIMENSION II(64),JJ(64),FG(30,30),X(96),Y(96)
      DIMENSION XMIK(64),YMIK(64)
	Write (*,'('' Program SCF Adapted from Greenwood, H. H.,'')')
	Write (*,'('' Computational Methods for Quantum Organic Chem.'')')
	Write (*,'('' Wiley-Interscience, New York, 1972'')')
      CALL SCFCON(NMOLS,EPS,HAFGAM,BETA)
 76   KMOLS=KMOLS+1
      IF (KMOLS-NMOLS) 77,77,78
 77   CONTINUE
      CALL SCFMA(N,M,FG,G,Z,X,Y,IX,IY)
      WRITE (*,500)
 500  FORMAT (     '     NDER? (I2)')
      READ (*,99) NDER
 99   FORMAT (I2)
      DO 83 I=1,NDER
      CALL SCFDR(N,F,FG,FDIAG,G,Z)
      MIND = 6
      CALL SCFPRI(N,MIND,FG,FDIAG,T,G,Z)
      CALL SCFMOD(N,F,FDIAG,G,Z)
      NIT = 0
 17   CALL SCFJAC(N,F,FDIAG,T,NIT,EPS)
      CALL SCFNFM(N,M,F,FDIAG,T,G,Z,HAFGAM)
      CALL SCFTRF(N,F,FDIAG,T)
      NIT = NIT+1
      IF (NIT-10) 17,17,18
 18   CALL SCFPIE(N,M,F,T,G,Z,X,Y)
      CALL SCFTRC(MINK,II,JJ,N,XMIK,YMIK,T,X,Y)
      MIND = 3
      CALL SCFPRI(N,MIND,F,FDIAG,T,G,Z)
      GO TO 76
 83    CONTINUE
 84    CONTINUE
 78   STOP
      END
      SUBROUTINE SCFJAC(N,A,ADIAG,U,NIT,EPS)
      DIMENSION A(30,30),U(30,30),ADIAG(30)
      IF (NIT) 10,999,10
 999  DO 8 J=1,N
      DO 9 I=1,N
 9    U(I,J)=0.
 8    U(J,J)=1.0
 10   AMAX=0.0
      DO 11 I=2,N
      JUP = I-1
      DO 11 J=1,JUP
      AII=ADIAG(I)
      AJJ=ADIAG(J)
      AOD=A(I,J)
      ASQ=AOD*AOD
 28   IF (ASQ-AMAX) 23,23,27
 27   AMAX=ASQ
 23   IF(ASQ-EPS)11,11,12
 12   DIFFR=AII-AJJ
      IF (DIFFR) 13,15,15
 13   SIGN=-2.0
      DIFFR=-DIFFR
      GO TO 16
 15   SIGN=2.0
 16   TDEN=DIFFR+SQRT(DIFFR*DIFFR+4.0*ASQ)
      TANK=SIGN*AOD/TDEN
      C=1.0/(SQRT(1.0+TANK*TANK))
      S=C*TANK
      DO 24 K=1,N
      XJ=C*U(K,J)-S*U(K,I)
      U(K,I)=S*U(K,J)+C*U(K,I)
      U(K,J)=XJ
      IF (K-J) 17,24,18
 17   XJ=C*A(J,K)-S*A(I,K)
      A(I,K)=S*A(J,K)+C*A(I,K)
      A(J,K)=XJ
      GO TO 24
 18   IF (K-I) 19,24,21
 19   XJ=C*A(K,J)-S*A(I,K)
      A(I,K)=S*A(K,J)+C*A(I,K)
      A(K,J)=XJ
      GO TO 24
 21   XJ=C*A(K,J)-S*A(K,I)
      A(K,I)=S*A(K,J)+C*A(K,I)
      A(K,J)=XJ
 24   CONTINUE
      ADIAG(I)=C*C*AII+S*S*AJJ+2.0*S*C*AOD
      ADIAG(J)=C*C*AJJ+S*S*AII-2.0*S*C*AOD
      A(I,J)=0
 11   CONTINUE
      IF (AMAX-EPS) 20,20,10
 20   RETURN
      END
      SUBROUTINE SCFCON(NMOLS,EPS,HAFGAM,BETA)
      EPS = 1.0E-16
      HAFGAM = 5.675
      BETA = -2.37
      WRITE (*,101)
 101  FORMAT(     '     NMOLS,  (I3)')
      READ (*,100) NMOLS
 100  FORMAT ( I3,I1)
      RETURN
      END
      SUBROUTINE SCFMA(N,M,FG,G,Z,XCRD,YCRD,IX,IY)
      DIMENSION FG(30,30),G(30,30),Z(30)
      DIMENSION IX(96),IY(96),NATM(96)
      DIMENSION XCRD(96),YCRD(96)
      DIMENSION X(96),Y(96)
      EL=1.399
      XT=0.8660254*EL
      YT=0.5*EL
      DO 4 I=1,96
      X(I)=IX(I)*XT
 4    Y(I)=IY(I)*YT
      WRITE (*,200)
 200  FORMAT (     '     N,M (2I3)')
      READ (*,99) N,M
      WRITE (*,500)
 500  FORMAT (   '   INPUT COORDINATES')
      WRITE (*,502)
 502  FORMAT (   '   X(I)? I=1,N (UNFORMATTED)')
      READ(*,*)(X(I),I=1,N)
      WRITE (*,503)
 503  FORMAT (   '   Y(I)? I=1,N (UNFORMATTED)')
      READ(*,*)(Y(I),I=1,N)
      WRITE (*,504)
 504  FORMAT (   '   ATOM NUMBER (I)? I=1,N (UNFORMATTED)')
      READ(*,*)(NATM(J),J=1,N)
      DO 550 I=1,N
      DO 550 J=1,N
 550  FG(I,J)=0.0
 1001 DO 10 I=1,N
      ID=NATM(I)
      XD=X(ID)
      YD=Y(ID)
      YCRD(I)=YD
      XCRD(I)=XD
      DO 10 J=I,N
      IF (I-J) 12,13,12
 13   G(I,I)=11.35
      GO TO 10
 12   JD=NATM(J)
      XC=X(JD)
      YC=Y(JD)
      D=SQRT((XC-XD)**2+(YC-YD)**2)
      IF(D-2.81) 14,14,51
 51   G(I,J)=14.4/D
      GO TO 10
 14   IF (D-2.75) 15,15,52
 52   G(I,J)=4.97
      GO TO 10
 15   IF (D-1.42) 16,16,17
 17   G(I,J)=5.77
      GO TO 10
 16   G(I,J)=7.19
 10   CONTINUE
      DO 19 I=1,N
      DO 19 J=I,N
      FG(I,J)=G(I,J)
 19   G(J,I)=G(I,J)
      IUPP=N-1
      DO 20 I=1,IUPP
      JLOW=I+1
      DO 20 J=JLOW,N
      IF (G(I,J)-7.0) 20,20,21
 21   FG(J,I)=-2.37
 20   CONTINUE
      DO 113 J=1,N
 113  Z(J)=1.0
      WRITE (*,903)
 903  FORMAT (5X,8H ATOM(I),5X,13H X-COORDINATE,5X,14H Y-COORDINATE )
      DO 1003 I=1,N
      WRITE (*,904) I,XCRD(I),YCRD(I)
 904  FORMAT (8X,I2,12X,F6.3,12X,F6.3)
 1003 CONTINUE
 98   FORMAT (35I2)
 99   FORMAT (2I3)
      RETURN
      END
      SUBROUTINE SCFDR(N,F,FG,FDIAG,GAM,Z)
      DIMENSION F(30,30),FG(30,30),GAM(30,30),Z(30),FDIAG(30)
      DO 10 J=1,N
      DO 10 I=J,N
      IF (I-J) 16,17,16
 16   F(I,J)=FG(I,J)
      F(J,I)=F(I,J)
      GO TO 10
 17   FDIAG (J)=0
      F(J,J)=0
 10   CONTINUE
      DO 11 I=1,N
      DO 11 J=I,N
      GAM(I,J)=FG(I,J)
 11   GAM(J,I)=GAM(I,J)
      DO 12 J=1,N
 12   Z(J)=1.0
      RETURN
      END
      SUBROUTINE SCFPRI(N,MIND,A,ADIAG,U,G,Z)
      DIMENSION A(30,30),ADIAG(30),U(30,30),G(30,30),Z(30)
      GO TO (9,10,11,12,13,14),MIND
 10   DO 19 J=2,N
      IUP=J-1
 19   WRITE( *,100) (A(I,J),I=1,IUP)
      WRITE (*,100) (ADIAG(J),J=1,N)
      GO TO 9
 11   WRITE (*,106)
 106  FORMAT (/24H SCF LEVELS AND ORBITALS)
      DO 17 J=1,N
      WRITE (*,112) ADIAG(J)
 112  FORMAT (1H0,1X,8HENERGY =,F11.4/)
 17   WRITE (*,111) (U(I,J),I=1,N)
 111  FORMAT (6(F10.5))
      GO TO 9
 12   WRITE (*,101) ((U(I,J),I=1,N),J=1,N)
      WRITE (*,100) (ADIAG(I),I=1,N)
      GO TO 9
 13   WRITE (*,103) ((A(I,J),I=1,J),J=1,N)
      WRITE (*,103) ((G(I,J),I=1,J),J=1,N)
      WRITE (*,105) (Z(J),J=1,N)
      GO TO 9
 14   WRITE (*,120)
 120  FORMAT (//,1H1,15H CORE INTEGRALS)
      WRITE (*,103) ADIAG(1)
      DO 71 J=2,N
      JLOW=J-1
      WRITE (*,103) (A(J,I),I=1,JLOW),ADIAG(J)
 71   CONTINUE
      WRITE(*,121)
 121  FORMAT(/29H ELECTRON REPULSION INTEGRALS)
      DO 72 I=1,N
      WRITE (*,103) (A(J,I),J=1,I)
 72   CONTINUE
 100  FORMAT (5E14.7)
 101  FORMAT (7F10.7)
 103  FORMAT (10F7.3)
 104  FORMAT (I3)
 105  FORMAT (15F4.2)
 9    RETURN
      END
      SUBROUTINE SCFMOD(N,F,FDIAG,GAM,Z)
      DIMENSION F(30,30), FDIAG(30), GAM (30,30), Z(30)
      WRITE (*,200)
 200  FORMAT (/)
 100  FORMAT (I2)
 101  FORMAT (I1)
 102  FORMAT (2I2,F7.3)
 103  FORMAT (I2,F3.1)
 104  FORMAT (3X,I2,1X,F4.1)
 202  FORMAT (1X,2I2,F7.3)
 7    WRITE (*,500)
 500  FORMAT (     '     OPTIONS? (I1)')
      READ (*,101) IOPT
      IF (IOPT) 9,8,9
 9    IF (IOPT-2) 66,67,68
 66   WRITE (*,130)
 130  FORMAT (16H F MODIFICATIONS)
      GO TO 69
 67   WRITE (*,131)
 131  FORMAT (16H G MODIFICATIONS)
      GO TO 69
 68   WRITE (*,132)
 132  FORMAT (16H Z MODIFICATIONS)
 69   WRITE (*,501)
 501  FORMAT (     '     NITEM? (I2)')
      READ (*,100) NITEM
      DO 20 K=1,NITEM
      GO TO (10,11,12), IOPT
 10   WRITE (*,502)
 502  FORMAT (     '     I,J,F(I,J) (2I2,F7.3)')
      READ (*,102) I,J,F(I,J)
      WRITE (*,202) I,J,F(I,J)
      IF (I-J) 120,20,120
 120  CONTINUE
      F(J,I)=F(I,J)
      GO TO 20
 11   WRITE (*,503)
 503  FORMAT (     '     I,J,GAM(I,J)? (2I2,F7.3)')
      READ (*,102) I,J,GAM(I,J)
      WRITE (*,202) I,J,GAM(I,J)
      IF (I-J) 121,20,121
 121  CONTINUE
      GAM(J,I)=GAM(I,J)
      GO TO 20
 12   WRITE (*,504)
 504  FORMAT (     '     J,Z(J)? (I2,F3.1)')
      READ (*,103) J,Z(J)
      WRITE (*,104) J,Z(J)
 20   CONTINUE
      GO TO 7
 8    DO 13 J=1,N
 13   FDIAG(J)=F(J,J)
      RETURN
      END
      SUBROUTINE SCFARR(N,A,ADIAG,U)
      DIMENSION A(30,30),ADIAG(30),U(30,30),UTEST(30)
      DO 40 K=1,N
      ATEST=ADIAG(K)
      JTEST=K
      DO 41 J=K,N
      IF (ADIAG(J)-ATEST) 42,41,41
 42   ATEST=ADIAG(J)
      JTEST=J
 41   CONTINUE
      ADIAG(JTEST)=ADIAG(K)
      ADIAG(K)=ATEST
      DO 40 I=1,N
      UTEST(I)=U(I,JTEST)
      U(I,JTEST)=U(I,K)
 40   U(I,K)=UTEST(I)
      RETURN
      END
      SUBROUTINE SCFNFM(N,M,F,FDIAG,T,G,Z,HAFGAM)
      DIMENSION F(30,30),FDIAG(30),T(30,30),G(30,30),Z(30),DIGR(30)
      DO 11 I=1,N
      DO 11 J=1,I
      RSUM=0
      DO 12 K=1,M
 12   RSUM=RSUM+T(I,K)*T(J,K)
      IF (J-I) 9,10,10
 9    F(I,J)=F(J,I)-RSUM*G(I,J)
      GO TO 11
 10   DIGR(I)=RSUM
 11   CONTINUE
      SUM=0
      DO 20 J=1,N
 20   SUM=SUM+DIGR(J)
      DO 21 J=1,N
 21   DIGR(J)=M*DIGR(J)/SUM
      DO 22 I=1,N
      RSUM=0.
      DO 23 J=1,N
      IF (I-J) 24,23,24
 24   RSUM=RSUM+(2.0*DIGR(J)-Z(J))*G(I,J)
 23   CONTINUE
 22   FDIAG(I)=F(I,I)-HAFGAM+DIGR(I)*G(I,I)+RSUM
      RETURN
      END
      SUBROUTINE SCFTRF(N,F,FDIAG,T)
      DIMENSION F(30,30),FDIAG(30),T(30,30),FS(30,30)
      DO 8 I=1,N
      DO 8 J=1,N
      SUM=0
      DO 7 K=1,N
      IF (K-I) 5,4,6
 4    SUM=SUM+FDIAG(K)*T(K,J)
      GO TO 7
 5    SUM=SUM+F(I,K)*T(K,J)
      GO TO 7
 6    SUM=SUM+F(K,I)*T(K,J)
 7    CONTINUE
 8    FS(I,J)=SUM
      DO 10 I=1,N
      DO 10 J=1,I
      SUM=0
      DO 11 K=1,N
 11   SUM=SUM+T(K,I)*FS(K,J)
      IF (I-J) 12,13,12
 12   F(I,J)=SUM
      GO TO 10
 13   FDIAG(J)=SUM
 10   CONTINUE
      RETURN
      END
      SUBROUTINE SCFPIE(N,M,F,T,G,Z,X,Y)
      DIMENSION X(96),Y(96)
      DIMENSION F(30,30),FDIAG(30),T(30,30),G(30,30),Z(30),R(30,30)
      DO 9 J=1,N
      DO 9 I=1,N
      SUM=0.
      DO 10 K=1,M
 10   SUM=SUM+T(I,K)*T(J,K)
 9    R(I,J)=SUM
      SUM=0
      DO 20 J=1,N
 20   SUM=SUM+R(J,J)
      DO 21 J=1,N
 21   R(J,J)=M*R(J,J)/SUM
      E=0.
      DO 8 I=1,N
      SIGK=0.
      DO 11 K=1,N
 11   SIGK=SIGK+2.0*(R(K,K)-Z(K))*G(I,K)
      DO 8 J=1,I
      BRAK=2.0*F(J,I)-R(I,J)*G(I,J)
      IF (I-J) 6,7,6
 7    TERM=SIGK+BRAK+2.0*Z(I)*G(I,I)
      GO TO 8
 6    TERM=2.0*BRAK
 8    E=E+R(I,J)*TERM
      WRITE (*,100) E
      DO 1 J=1,N
      DO 1 I=1,J
 1    R(I,J)=2*R(I,J)
      SX=0
      SY=0
      DO 18 I=1,N
      P=R(I,I)-Z(I)
      SX=SX+P*X(I)
 18   SY=SY+P*Y(I)
      EMU=4.77*SQRT(SX*SX+SY*SY)
      SX=4.77*SX
      SY=4.77*SY
      WRITE (*,109) EMU,SX,SY
 109  FORMAT (/15H DIPOLE MOMENT=,F8.4,2X,5H XMU=,
     1F8.4,2X,5H YMU=,F8.4)
      WRITE (*,102)
 102  FORMAT (/30H DENSITY AND BOND ORDER MATRIX)
      DO 77 J=1,N
 77   WRITE (*,101) (R(I,J),I=1,J)
 100  FORMAT (/18H BINDING ENERGY E=,F16.8)
 101  FORMAT (6(F9.5,2X))
      PAUSE
      RETURN
      END
      SUBROUTINE SCFTRC(MINK,II,JJ,N,XMIK,YMIK,C,X,Y)
      DIMENSION C(30,30),II(64),JJ(64),XMIK(64),YMIK(64)
      DIMENSION X(96),Y(96)
      DO 18 I=1,MINK
      JI=II(I)
      JK=JJ(I)
      SX=0
      SY=0
      DO 27 L=1,N
      C1=C(L,JI)*C(L,JK)
      SX=SX+C1*X(L)
 27   SY=SY+C1*Y(L)
      XMIK(I)=SX
 18   YMIK(I)=SY
      RETURN
      END
