C       PROGRAM TO COMPUTE EIGENVALUES AND EIGENVECTORS
C       BY JACOBI METHOD
00001   DIMENSION A(20,20),S(20,20)
       WRITE(*,49)
   49  FORMAT(' INPUT IS FORMAT-FREE, SEPARATE WITH COMMAS')
       WRITE(*,50)
   50  FORMAT(' INPUT COMPOUND NAME (Test input is "ethene")')
00135   READ(*,*)
       WRITE(*,51)
   51  FORMAT(' INPUT MATRIX DIMENSION (Test input is "2")')
       READ(*,*)N
C       GENERATE IDENTITY MATRIX AS FIRST APPROXIMATION TO X
00020  DO 150 I=1,N
00030  DO 150 J=1,N
00040  A(I,J)=0.0
00041 IF(I-J) 100,101,100
00100  S(I,J)=0.0
	 GO TO 150
00101  S(I,J)=1.0
00150  CONTINUE
C       SET INDICATOR WHICH CHECKS OFF-DIAGONAL ELEMENTS
00045  INDIC=0
       WRITE(*,52)
   52  FORMAT(' INP MAT ELEM, ONE LINE EACH (Test inp. "1,2,1.0,99")')
00152  READ (*,*) I,J,FA,IND
00055  A(I,J)=-FA
00060  A(J,I)=-FA
00065  IF (IND) 151,152,151
C        COMPUT INITIAL NORM
00151  VI=0.0
00070  DO 106 I=1,N
00073  DO 106 J=1,N
00075  IF(I-J) 107,106,107
00107  VI=VI+A(I,J)**2
00106  CONTINUE
00077  VI=SQRT(VI)
C       COMPUTE FINAL NORM
00079  VF=VI*0.1E-07
C       COMPUTE THRESHOLD NORM
00080  AN=N
00128  VI=VI/AN
C       SET UP SYSTEMATIC SEARCH
00137 IQ=1
00124  IQ=IQ+1
00083  IP=0
00121  IP=IP+1
00085  IF (A(IP,IQ))108,120,109
00108  IF (-A(IP,IQ)-VI) 120,112,112
00109  IF (A(IP,IQ)-VI) 120,112,112
00112  INDIC=1
C       COMPUTE SINE AND COSINE OF MATRIX ROTATION ANGLE
00087  ALAM=-A(IP,IQ)
00089  AMU=0.5*(A(IP,IP)-A(IQ,IQ))
00090  IF (AMU) 113,114,114
00113  SGN=-1.0
00091  GO TO 115
00114  SGN=+1.0
00115  OMEGA=SGN*ALAM/SQRT(ALAM**2+AMU**2)
00092  STHT=OMEGA/SQRT(2.0+2.0*SQRT(1.0-OMEGA**2))
00093  CTHT=SQRT(1.0-STHT**2)
C       TRANSFORM ELEMENTS OF THE PTH AND QTH COLUMN
00094  DO 116 I=1,N
00095  IF(I-IP) 117,118,117
00117  IF(I-IQ) 119,118,119
C       ROTATE THE SECULAR MATRIX
00119  AIPI=A(IP,I)*CTHT-A(IQ,I)*STHT
00096  AIQI=A(IP,I)*STHT+A(IQ,I)*CTHT
00097  A(IP,I)=AIPI
00098  A(IQ,I)=AIQI
C       ROTATE THE MATRIX OF COEFFICIENTS
00118  AIPI=S(I,IP)*CTHT-S(I,IQ)*STHT
00099  AIQI=S(I,IP)*STHT+S(I,IQ)*CTHT
00102  S(I,IP)=AIPI
00116  S(I,IQ)=AIQI
00103  AIPI=A(IP,IP)*CTHT**2+A(IQ,IQ)*STHT**2-2.*A(IP,IQ)*STHT*CTHT
00104  AIQI=A(IP,IP)*STHT**2+A(IQ,IQ)*CTHT**2+2.0*A(IP,IQ)*STHT*CTHT
	AIPIQ=(A(IP,IP)-A(IQ,IQ))*CTHT*STHT+A(IP,IQ)*(CTHT**2-STHT**2)
	A(IP,IP)=AIPI
	A(IQ,IQ)=AIQI
	A(IP,IQ)=AIPIQ
00111  A(IQ,IP)=A(IP,IQ)
C       TRANSFORM MATRIX
	DO 123 I=1,N
	A(I,IP)=A(IP,I)
00123  A(I,IQ)=A(IQ,I)
00120  IF(IP-IQ+1) 121,122,122
00122  IF(IQ-N) 124,125,125
00125  IF(INDIC) 126,127,126
00126  INDIC=0
	GO TO 137
00127  IF(VI-VF) 129,129,128
C       OUTPUT COMPOUND NAME
00129  WRITE(*,8)
C       OUTPUT ROOTS TO POLYNOMIAL
	DO 130 I=1,N
	PAUSE
	DO 130 J=1,N
	IF(I-J) 130,131,130
00131  WRITE(*,5)I,A(I,J)
C       OUTPUT CORRESPONDING COEFFICIENTS
	WRITE(*,5)J
	DO 208 IP=1,N
00208  WRITE(*,3)IP,J,S(IP,J)
00130  CONTINUE
C 
C       FORMAT STATEMENTS
00002   FORMAT(I5,I5,F10.4,I2)
00003  FORMAT (4X,I5,I5,E20.8)
00005  FORMAT(//2X,8HROOT NO.I3,3H = ,E15.8)
00006  FORMAT (//2X31HCOEFFICIENTS OF WAVE FUNCTION (I3,1H)//)
00007  FORMAT(19X19H                   )
00008  FORMAT (//)
	END






